require("Enemy_Spinner")
require("Math_Util")

function new_spawn_manager(game_area)
	return
		{
			delay = 0,
			max_delay = 1,
		
			update = function(this, delta_t)
				this.delay = this.delay - delta_t
				if this.delay < 0 then
					this.delay = this.max_delay
					this.max_delay = clamp(this.max_delay - 0.02, 0.1, 100)
					
					local spawn_x = rand_float(-game_area.size_x, game_area.size_x)
					local spawn_y = game_area.spawn_z
					
					local enemy = new_enemy_spinner(game_area, vec3(spawn_x, 0, spawn_y))
					game_area:add_enemy(enemy)
				end
				end,
		}
end
